package com.flyfish.framework.exception.biz;

import com.flyfish.framework.exception.BaseException;

import java.util.function.Supplier;

/**
 * 数据缺失异常，会抛出404
 *
 * @author wangyu
 */
public class DataLackException extends BaseException {

    private static final long serialVersionUID = -2048295927616443440L;

    private int status = 404;

    public DataLackException(String message) {
        super(message);
    }

    public static DataLackException msg(String message) {
        return new DataLackException(message);
    }

    public static Supplier<DataLackException> supplier(String message) {
        return () -> msg(message);
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }
}
