package com.flyfish.framework.beans.meta;

import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.util.List;
import java.util.Objects;

/**
 * bean的属性们
 *
 * @author wangyu
 */
@Data
public class BeanInfo {

    // bean的编码
    private String code;

    // bean的显示名
    private String name;

    // bean的类型
    private String type;

    // 默认layout
    private String layout;

    // 分组们
    private List<BeanPropertyGroup> groups;

    // bean的属性们
    private List<BeanProperty> properties;

    // 表格列属性
    private List<BeanProperty> columns;

    // 表格查询属性
    private List<BeanProperty> search;

    /**
     * 自由设置值
     *
     * @param key   键
     * @param value 值
     */
    public void set(String key, Object value) {
        try {
            Objects.requireNonNull(BeanUtils.getPropertyDescriptor(this.getClass(), key))
                    .getWriteMethod().invoke(this, value);
        } catch (Exception ignored) {

        }
    }
}
